---
title: HTMLInputElement.setSelectionRange()
slug: Web/API/HTMLInputElement/setSelectionRange
tags:
  - API
  - HTML DOM
  - HTMLInputElement
  - Method
  - Reference
  - Text Field Selection API
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>HTMLInputElement.setSelectionRange()</code></strong> method sets the start and end positions of the current text selection in an {{HTMLElement("input")}} or {{HTMLElement("textarea")}} element.</p>

<p>Optionally, in newer browser versions, you can specify the direction in which selection should be considered to have occurred. This lets you indicate, for example, that the selection was set by the user clicking and dragging from the end of the selected text toward the beginning.</p>

<p>This method updates the <code>HTMLInputElement.selectionStart</code>, <code>selectionEnd</code>, and <code>selectionDirection</code> properties in one call.</p>

<p>Note that accordingly to the <a href="https://html.spec.whatwg.org/multipage/forms.html#concept-input-apply">WHATWG forms spec</a> <code>selectionStart</code>, <code>selectionEnd</code> properties and <code>setSelectionRange</code> method apply only to inputs of types text, search, URL, tel and password. Chrome, starting from version 33, throws an exception while accessing those properties and method on the rest of input types. For example, on input of type number: "Failed to read the 'selectionStart' property from 'HTMLInputElement': The input element's type ('number') does not support selection".</p>

<p>If you wish to select <strong>all</strong> text of an input element, you can use the <a href="/en-US/docs/Web/API/HTMLInputElement/select">HTMLInputElement.select()</a> method instead.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>element</em>.setSelectionRange(<em>selectionStart</em>, <em>selectionEnd</em> [, <em>selectionDirection</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<p>If <code>selectionEnd</code> is less than <code>selectionStart</code>, then both are treated as the value of <code>selectionEnd</code>.</p>

<dl>
 <dt><code>selectionStart</code></dt>
 <dd>The 0-based index of the first selected character. An index greater than the length of the element's value is treated as pointing to the end of the value.</dd>
 <dt><code>selectionEnd</code></dt>
 <dd>The 0-based index of the character <em>after</em> the last selected character. An index greater than the length of the element's value is treated as pointing to the end of the value.</dd>
 <dt><code>selectionDirection</code> {{optional_inline}}</dt>
 <dd>A string indicating the direction in which the selection is considered to have been performed. Possible values:
 <ul>
  <li><code>"forward"</code></li>
  <li><code>"backward"</code></li>
  <li><code>"none"</code> if the direction is unknown or irrelevant. Default value.</li>
 </ul>
 </dd>
</dl>

<h2 id="Example">Example</h2>

<p>Click the button in this example to select the third, fourth, and fifth characters in the text box ("zil" in the word "Mozilla").</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;input type="text" id="text-box" size="20" value="Mozilla"&gt;
&lt;button onclick="selectText()"&gt;Select text&lt;/button&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">function selectText() {
  const input = document.getElementById('text-box');
  input.focus();
  input.setSelectionRange(2, 5);
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "forms.html#dom-textarea/input-setselectionrange", "HTMLInputElement.setSelectionRange()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "forms.html#dom-textarea/input-setselectionrange", "HTMLInputElement.setSelectionRange()")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "forms.html#dom-textarea/input-setselectionrange", "HTMLInputElement.setSelectionRange()")}}</td>
   <td>{{Spec2("HTML5 W3C")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLInputElement.setSelectionRange")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTMLElement("input")}}</li>
 <li>{{HTMLElement("textarea")}}</li>
 <li>{{domxref("HTMLInputElement")}}</li>
 <li>{{domxref("Selection")}}</li>
</ul>
